//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;



namespace OQJ_BSMouseListener
{
	public static class BSMouseListener
	{
		static bool pr_PRESSING;

		static bool pr_DRAGGING;

		static Vector2Int pr_MP = new Vector2Int();
		static Vector2Int pr_diffVtr = new Vector2Int();



		public static bool IsMousePressed()   
		{

			return Input.GetMouseButtonDown(0);
		}



		public static bool IsMousePressing()
		{
			return pr_PRESSING;
		}



		public static bool IsMouseReleased()
		{

			return Input.GetMouseButtonUp(0);
		}


		public static bool IsMouseDragged()
		{
			if (pr_DRAGGING) { return true; }

			if (pr_PRESSING)
			{
				int wx = Mathf.RoundToInt(Input.mousePosition.x);
				int wy = Mathf.RoundToInt(Input.mousePosition.y);

				if ((Mathf.Abs(pr_MP.x - wx) > 1) || (Mathf.Abs(pr_MP.y - wy) > 1))
				{
					pr_diffVtr.x = wx - pr_MP.x;
					pr_diffVtr.y = wy - pr_MP.y;
					pr_MP.x = wx;
					pr_MP.y = wy;

					pr_DRAGGING = true;

					return true;
				}
			}

			return false;
		}



		public static void MouseDragProcess()
		{


			pr_DRAGGING = false;	


			if (!pr_PRESSING && Input.GetMouseButtonDown(0))
			{
				pr_PRESSING = true;
				pr_MP.x = (int)Input.mousePosition.x;
				pr_MP.y = (int)Input.mousePosition.y;
			}


			if (pr_PRESSING && Input.GetMouseButtonUp(0))
			{
				pr_PRESSING = false;

				return;
			}
		}



		public static Vector2 GetMouseDifference()
		{
			return new Vector2(pr_diffVtr.x, pr_diffVtr.y);
		}

	}
}
