﻿//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------


Shader "Custom/ColoredVertex"
{
    SubShader
    {
        Pass {
            CGPROGRAM
        
            #pragma vertex vert
            #pragma fragment frag

            struct V_IN {
                float3 pos_Loc : POSITION;
                fixed3 color : COLOR0;
            };

			struct V_OUT {
                float4 pos_Hom : SV_POSITION;
                fixed3 color : COLOR0;
			};


            V_OUT vert(V_IN v) {
                V_OUT o;

                // Upgrade NOTE: replaced 'mul(UNITY_MATRIX_MVP,*)' with 'UnityObjectToClipPos(*)'
                o.pos_Hom = UnityObjectToClipPos(float4(v.pos_Loc, 1));
                o.color = v.color;
                
                return o;
            }


            fixed4 frag(V_OUT o) : SV_TARGET{
                return fixed4(o.color, 1);
            }

            ENDCG
        }
    }
}
