//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec101
{
	public class Sec101 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;




		void Code1()
		{
			Vector2 v1 = new Vector2(10, 20);
			Vector2 v2 = new Vector2(8.91f, -5.643f);
			Vector3 v3 = new Vector3(128, 256, 512);
			Vector3 v4 = new Vector3(-20.5f, 310.83f, 98.048f);
			
			Debug.Log(v1);
			Debug.Log(v2);
			Debug.Log(v3);
			Debug.Log(v4);
		}


		void Code2()
		{
			Vector2 a = new Vector2(3, 5);
			Vector2 b = new Vector2(11, -4);
			Vector2 v = a + b;
			Debug.Log(v);
			
			a = new Vector3(2.5f, 5.4f);
			b = new Vector3(-4.1f, 8.6f);
			v = a - b;
			Debug.Log(v);
			
			Vector3 c = new Vector3(1.5f, 3.0f, 4.5f);
			Vector3 d = new Vector3(2.2f, 4.4f, 6.6f);
			Vector3 w = c + d;
			Debug.Log(w);
			
			c = new Vector3(10, 15, 20);
			d = new Vector3(4, 8, 12);
			w = c - d;
			Debug.Log(w);
		}


		void Code3()
		{
			Vector2 v1 = new Vector2(4, 2);
			Vector2 v2 = new Vector2(1, 3);
			Vector2 v3 = new Vector2(-3, 9);
			Debug.Log("|v1| : " + v1.magnitude);
			Debug.Log("|v2| : " + v2.magnitude);
			Debug.Log("|v3| : " + v3.magnitude);
			
			Vector2 v4 = 2.0f * v1;
			Vector2 v5 = -0.4f * v1;
			Debug.Log("v4 : " + v4);
			Debug.Log("v5 : " + v5);
			
			Vector2 v6 = 3.0f * v1 + 5.0f * v2;
			Vector2 v7 = 6.2f * v2 - 1.8f * v3;
			Debug.Log("v6 : " + v6);
			Debug.Log("v7 : " + v7);
		}


		void Code4()
		{
			Vector2 a = new Vector2(7.4f, 4.1f);
			Vector2 b = new Vector2(11, -5);
			float len = (b - a).magnitude;
			Debug.Log(len);
			
			len = (new Vector2(11, -5) - new Vector2(7.4f, 4.1f)).magnitude;
			Debug.Log(len);
		}


		void Code5()
		{
			Vector2 a = new Vector2(2, 3);
			Vector2 b = new Vector2(5, 6);
			float val = Vector2.Dot(a, b);
			Debug.Log("Dot(a, b) : " + val);
			
			Vector2 v = new Vector2(8, -4);
			Vector2 w = new Vector2(-11, -9);
			val = Vector2.Dot(v, w);
			Debug.Log("Dot(v, w) : " + val);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

				case 4 :	Code4();  break;

				case 5 :	Code5();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec101 pr_instance = new Sec101(5);

		public static Sec101 PRGSI()
		{
			return pr_instance;
		}


		private Sec101(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			
			if (MatchCase(1, 2, 3, 4, 5))
			{
				pr_LOOP_CODE = false;
			}
		}

	}

}
