//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec103
{
	public class Sec103 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;




		void Code1()
		{
			Vector2 v1 = new Vector2(8, 10);
			Vector2 u1 = v1.normalized;
			// Debug.Log(u1);
			Debug.Log("(" + u1.x + ", " + u1.y + ")" + " : mag " + u1.magnitude);
			
			Vector2 v2 = new Vector2(12.536f, -7.033f);
			Vector2 u2 = v2.normalized;
			Debug.Log("(" + u2.x + ", " + u2.y + ")" + " : mag " + u2.magnitude);
			
			Vector3 v3 = new Vector3(0.52f, -20.12f, 4.605f);
			Vector3 u3 = v3.normalized;
			Debug.Log("(" + u3.x + ", " + u3.y + ", " + u3.z + ")" + " : mag " + u3.magnitude);
			
			Vector3 u4 = new Vector3(-2.4f, 1.8f, 8.9f).normalized;
			Debug.Log("(" + u4.x + ", " + u4.y + ", " + u4.z + ")" + " : mag " + u4.magnitude);
		}


		void Code2()
		{
			Vector2 P = new Vector2(-1, 1);
			Vector2 v = new Vector2(3, 2);
			Vector2 u = v.normalized;
			
			Vector2 P1 = P + 3 * u;
			Debug.Log("(" + P1.x + ", " + P1.y + ")");
			Debug.Log("|3u| : " + (3 * u).magnitude);
		}


		void Code3()
		{
			Vector2 P = new Vector2(-2, 2);
			Vector2 Q = new Vector2(1, 3);
			Vector2 v = Q - P;
			Vector2 u = v.normalized;
			// Vector2 u = (Q - P).normalized;
			
			Vector2 Q1 = P + 5 * u;
			Debug.Log("(" + Q1.x + ", " + Q1.y + ")");
		}


		void Code4()
		{
			Vector2 v = new Vector2(6, 6);
			Vector2 u = (new Vector2(8, 2)).normalized;
			float OQ = Vector2.Dot(v, u);
			
			Debug.Log("|OQ| = "+OQ);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

				case 4 :	Code4();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec103 pr_instance = new Sec103(4);

		public static Sec103 PRGSI()
		{
			return pr_instance;
		}


		private Sec103(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1, 2, 3, 4))
			{
				pr_LOOP_CODE = false;
			}
		}

	}

}
