//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec104
{
	public class Sec104 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Disk;




		void Code1()
		{
			// 行列と行列の積
			Vector3 a1 = new Vector3(1, 4, 7);      // 第1列
			Vector3 a2 = new Vector3(2, 5, 8);      // 第2列
			Vector3 a3 = new Vector3(3, 6, 9);      // 第3列
			THMatrix3x3 A = new THMatrix3x3(a1, a2, a3);
			
			Vector3 b1 = new Vector3(11, 12, 13);   // 第1列
			Vector3 b2 = new Vector3(14, 15, 16);   // 第2列
			Vector3 b3 = new Vector3(17, 18, 19);   // 第3列
			THMatrix3x3 B = new THMatrix3x3(b1, b2, b3);
			
			THMatrix3x3 M = A * B;
			Debug.Log(M);
			M = B * A;
			Debug.Log(M);
			
			// 行列とベクトルの積
			a1 = new Vector3(6, 3, 8);
			a2 = new Vector3(1, 4, 0);
			a3 = new Vector3(5, 2, 7);
			A = new THMatrix3x3(a1, a2, a3);
			Vector3 w = new Vector3(5, 0, 1);
			Vector3 v = A * w;
			Debug.Log(v);
			
			a1 = new Vector3(1, 0, 13);
			a2 = new Vector3(11, 9, 3);
			a3 = new Vector3(2, 5, 0);
			A = new THMatrix3x3(a1, a2, a3);
			w = new Vector3(2, 4, 6);
			v = A * w;
			Debug.Log(v);
		}


		void Code2()
		{
			// Diskは何の変換も受けていない状態になる
			Disk.SetMatrix(THMatrix3x3.identity);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec104 pr_instance = new Sec104(2);

		public static Sec104 PRGSI()
		{
			return pr_instance;
		}


		private Sec104(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Disk = CreateObject_Obj2D("DiskB");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1))
			{
				pr_LOOP_CODE = false;
			}
			else if (MatchCase(2))
			{
				BSAuxFuncs.SetVisible(1, Disk.gameObject);
				Disk.SetMatrix(THMatrix3x3.identity);
				
				pr_LOOP_CODE = false;
				
			}
		}

	}

}
