//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec105
{
	public class Sec105 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Square;




		void Code1()
		{
			Vector3 P = new Vector3(2, 1, 1);  // (2, 1) の同次座標
			
			//(1)
			THMatrix3x3 T1 = TH2DMath.GetTranslation3x3(-3, -4);
			THMatrix3x3 T2 = TH2DMath.GetTranslation3x3(2, 6);
			THMatrix3x3 M1 = T2 * T1;
			Vector3 P1 = M1 * P;
			Debug.Log(P1);
			
			//(2)
			T1 = TH2DMath.GetTranslation3x3(3, 0);
			T2 = TH2DMath.GetTranslation3x3(-5, 4);
			THMatrix3x3 T3 = TH2DMath.GetTranslation3x3(-2, -2);
			THMatrix3x3 M2 = T3 * T2 * T1;
			Vector3 P2 = M2 * P;
			Debug.Log(P2);
		}


		void Code2()
		{
			THMatrix3x3 T1 = TH2DMath.GetTranslation3x3(-6, 3);
			THMatrix3x3 T2 = TH2DMath.GetTranslation3x3(4, 4);
			THMatrix3x3 M = T2 * T1;
			Square.SetMatrix(M);
		}


		void Code3()
		{
			THMatrix3x3 T1 = TH2DMath.GetTranslation3x3(1, 5);
			THMatrix3x3 T2 = TH2DMath.GetTranslation3x3(-4, 1);
			THMatrix3x3 T3 = TH2DMath.GetTranslation3x3(-1, -5);
			THMatrix3x3 M = T3 * T2 * T1;
			Square.SetMatrix(M);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec105 pr_instance = new Sec105(3);

		public static Sec105 PRGSI()
		{
			return pr_instance;
		}


		private Sec105(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Square = CreateObject_Obj2D("Square");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1))
			{
				pr_LOOP_CODE = false;
			}
			else if (MatchCase(2, 3))
			{
				BSAuxFuncs.SetVisible(1, Square.gameObject);
				Square.SetMatrix(THMatrix3x3.identity);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
