//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec106
{
	public class Sec106 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Octagon;




		void Code1()
		{
			// (1) 80°, 70° の順で回転
			THMatrix3x3 R1 = TH2DMath.GetRotation3x3(80);
			THMatrix3x3 R2 = TH2DMath.GetRotation3x3(70);
			THMatrix3x3 M = R2 * R1;
			Vector2 P1 = M * new Vector3(1, 0, 1);
			Debug.Log("(" + P1.x + ", " + P1.y + ")");
			
			// (2) 160°, 120°, -60° の順で回転
			R1 = TH2DMath.GetRotation3x3(160);
			R2 = TH2DMath.GetRotation3x3(120);
			THMatrix3x3 R3 = TH2DMath.GetRotation3x3(-60);
			M = R3 * R2 * R1;
			Vector2 P2 = M * new Vector3(1, 0, 1);
			Debug.Log("(" + P2.x + ", " + P2.y + ")");
		}


		void Code2()
		{
			THMatrix3x3 R = TH2DMath.GetRotation3x3(30);
			Octagon.SetMatrix(R);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec106 pr_instance = new Sec106(2);

		public static Sec106 PRGSI()
		{
			return pr_instance;
		}


		private Sec106(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Octagon = CreateObject_Obj2D("Octagon");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1))
			{
				pr_LOOP_CODE = false;
			}
			else if (MatchCase(2))
			{
				BSAuxFuncs.SetVisible(1, Octagon.gameObject);
				Octagon.SetMatrix(THMatrix3x3.identity);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
