//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec107
{
	public class Sec107 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Circle;




		void Code1()
		{
			Vector3 R = new Vector3(2, 0, 1);
			Vector3 G = new Vector3(2, 2, 1);
			Vector3 B = new Vector3(0, 2, 1);
			
			THMatrix3x3 S1 = TH2DMath.GetScale3x3(2.0f);
			THMatrix3x3 S2 = TH2DMath.GetScale3x3(0.5f, 1.0f);
			THMatrix3x3 S3 = TH2DMath.GetScale3x3(1.0f, 1.5f);
			
			Vector2 sR = S3 * R;
			Vector2 sG = S3 * G;
			Vector2 sB = S3 * B;
			Debug.Log("S3 * R : " + sR);
			Debug.Log("S3 * G : " + sG);
			Debug.Log("S3 * B : " + sB);
		}


		void Code2()
		{
			THMatrix3x3 S = TH2DMath.GetScale3x3(2.5f, 1.5f);
			Circle.SetMatrix(S);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec107 pr_instance = new Sec107(2);

		public static Sec107 PRGSI()
		{
			return pr_instance;
		}


		private Sec107(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Circle = CreateObject_Obj2D("Circle");
				
				MeshRenderer mre = Circle.gameObject.GetComponent<MeshRenderer>();
				mre.material = BSAuxFuncs.GetSemiTransparentMaterial(0.0f, 0.5f, 0.8f, 0.45f);

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1))
			{
				pr_LOOP_CODE = false;
			}
			else if (MatchCase(2))
			{
				BSAuxFuncs.SetVisible(1, Circle.gameObject);
				Circle.SetMatrix(THMatrix3x3.identity);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
