//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec108
{
	public class Sec108 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Disk;




		void Code1()
		{
			THMatrix3x3 R45 = TH2DMath.GetRotation3x3(45);
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(0, 4);
			THMatrix3x3 M = T * R45;
			Disk.SetMatrix(M);
		}


		void Code2()
		{
			THMatrix3x3 R45 = TH2DMath.GetRotation3x3(45);
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(0, 4);
			THMatrix3x3 R90 = TH2DMath.GetRotation3x3(90);
			THMatrix3x3 M = R90 * T * R45;
			Disk.SetMatrix(M);
		}


		void Code3()
		{
			THMatrix3x3 S = TH2DMath.GetScale3x3(2, 2);
			THMatrix3x3 R = TH2DMath.GetRotation3x3(225);
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(-4, -4);
			THMatrix3x3 M = T * R * S;
			Disk.SetMatrix(M);
			
			
			
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec108 pr_instance = new Sec108(3);

		public static Sec108 PRGSI()
		{
			return pr_instance;
		}


		private Sec108(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Disk = CreateObject_Obj2D("DiskB");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1, 2, 3))
			{
				BSAuxFuncs.SetVisible(1, Disk.gameObject);
				Disk.SetMatrix(THMatrix3x3.identity);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
