//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec109
{
	public class Sec109 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Circle;      


		// Instance Variables
		float i_nextTime = 2;




		void Code1()
		{
			i_frameCount++;
			if (Time.time >= i_nextTime)
			{
				Debug.Log(Time.time + "  :  " + i_frameCount);
				i_frameCount = 0;
				i_nextTime = Time.time + 1;
			}
		}


		void Code2()
		{
			if (Input.GetKeyDown(KeyCode.M))
			{
				i_MOVE = true;
				i_frameCount = 0;
			}
			
			i_frameCount++;
			int nFrames = 4;  
			if (i_MOVE)
			{
				float mx = (i_frameCount - 1) * (4.0f / (nFrames - 1));
				THMatrix3x3 T = TH2DMath.GetTranslation3x3(mx, 0.0f);
				Circle.SetMatrix(T);
			}
			
			if (i_frameCount == nFrames)
			{
				i_MOVE = false;
			}
		}


		void Code3()
		{
			if (Input.GetKeyDown(KeyCode.M))
			{
				i_MOVE = true;
				i_frameCount = 0;
			}
			
			i_frameCount++;
			int nFrames = 16;
			if (i_MOVE)
			{
				float mx = (i_frameCount - 1) * (4.0f / (nFrames - 1));
				THMatrix3x3 T = TH2DMath.GetTranslation3x3(mx, 0.0f);
				Circle.SetMatrix(T);
			}
			
			if (i_frameCount == nFrames)
			{
				i_MOVE = false;
			}
		}


		void Code4()
		{
			if (Input.GetKeyDown(KeyCode.M))
			{
				i_MOVE = true;
				i_frameCount = 0;
			}
			
			i_frameCount++;
			int nFrames = 60;
			if (i_MOVE)
			{
				float mx = (i_frameCount - 1) * (4.0f / (nFrames - 1));
				THMatrix3x3 T = TH2DMath.GetTranslation3x3(mx, 0.0f);
				Circle.SetMatrix(T);
			}
			
			if (i_frameCount == nFrames)
			{
				i_MOVE = false;
			}
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

				case 4 :	Code4();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec109 pr_instance = new Sec109(4);

		public static Sec109 PRGSI()
		{
			return pr_instance;
		}


		private Sec109(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Circle = CreateObject_Obj2D("QrCircle");
				
				MeshRenderer mre = Circle.gameObject.GetComponent<MeshRenderer>();
				mre.material = BSAuxFuncs.GetSemiTransparentMaterial(0.0f, 0.5f, 0.8f, 0.35f);

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(5.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1))
			{
				SetFPS(60);  
				SetCameraPosition_2D(0, 0);
			}
			else if (MatchCase(2, 3, 4))
			{
				BSAuxFuncs.SetVisible(1, Circle.gameObject);
				Circle.SetMatrix(THMatrix3x3.identity);
				
				Circle.SetPosition(-100, 0);
				
				switch (THSettings.CODE_NR)
				{
					case 2: SetFPS(4); break;

					case 3: SetFPS(16); break;

					case 4: SetFPS(60); break;
				}
				
				SetCameraPosition_2D(2, 0);
			}
		}

	}

}
