//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec201
{
	public class Sec201 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D DiskB;
		THObject2D DiskR;
		THObject2D AuxCircle;


		// Instance Variables
		int i_degree = 0;




		void Code1()
		{
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(1, 0);
			DiskB.SetMatrix(T);
		}


		void Code2()
		{
			i_degree += 1;
			THMatrix3x3 R = TH2DMath.GetRotation3x3(i_degree);
			DiskR.SetMatrix(R);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
			if (MatchCase(1))
			{
			}
			else if (MatchCase(2))
			{
				Vector2 wp = DiskR.GetPosition();
				if (wp.x > -1)
				{
					AuxCircle.transform.localPosition = Vector3.zero;
				}
				else
				{
					AuxCircle.transform.localPosition = new Vector3(-100, 0, 0);
				}
			}
		}


		static Sec201 pr_instance = new Sec201(2);

		public static Sec201 PRGSI()
		{
			return pr_instance;
		}


		private Sec201(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				DiskB = CreateObject_Obj2D("DiskB");
				DiskR = CreateObject_Obj2D("DiskR");
				AuxCircle = CreateObject_Obj2D("AuxCircle");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(7.5f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			i_degree = 0;
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, DiskB.gameObject);
				BSAuxFuncs.SetVisible(1, DiskR.gameObject);
				
				DiskB.SetMatrix(THMatrix3x3.identity);
				DiskR.SetMatrix(THMatrix3x3.identity);
				
				DiskB.SetPosition(-100, 0);
				DiskR.SetPosition(-100, 0);
				
				pr_LOOP_CODE = false;
			}
			else if (MatchCase(2))
			{
				BSAuxFuncs.SetVisible(1, DiskB.gameObject);
				BSAuxFuncs.SetVisible(1, DiskR.gameObject);
				BSAuxFuncs.SetVisible(1, AuxCircle.gameObject);
				
				DiskB.SetMatrix(THMatrix3x3.identity);
				DiskR.SetMatrix(THMatrix3x3.identity);
				
				DiskB.SetPosition(-100, 0);
				DiskR.SetPosition(-100, 0);
				AuxCircle.SetMatrix(TH2DMath.GetScale3x3(2.0f));
			}
		}

	}

}
