//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec208
{
	public class Sec208 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Point;
		THObject2D DirBar;


		// Instance Variables
		int i_forwardDegree = 0;




		void Code1()
		{
			if (Input.GetKeyDown(KeyCode.H))
			{
				Debug.Log("PRESSED : H");
			}
			else if (Input.GetKeyDown(KeyCode.J))
			{
				Debug.Log("PRESSED : J");
			}
			else if (Input.GetKeyDown(KeyCode.K))
			{
				Debug.Log("PRESSED : K");
			}
			else if (Input.GetKeyDown(KeyCode.L))
			{
				Debug.Log("PRESSED : L");
			}
			
			else if (Input.GetKeyDown(KeyCode.Alpha1))
			{
				Debug.Log("PRESSED : 1");
			}
			else if (Input.GetKeyDown(KeyCode.Alpha2))
			{
				Debug.Log("PRESSED : 2");
			}
			else if (Input.GetKeyDown(KeyCode.Alpha3))
			{
				Debug.Log("PRESSED : 3");
			}
		}


		void Code2()
		{
			if (Input.GetKey(KeyCode.H))
			{
				Debug.Log("pressing : H");
			}
			else if (Input.GetKey(KeyCode.J))
			{
				Debug.Log("pressing : J");
			}
			else if (Input.GetKey(KeyCode.K))
			{
				Debug.Log("pressing : K");
			}
			else if (Input.GetKey(KeyCode.L))
			{
				Debug.Log("pressing : L");
			}
		}


		void Code3()
		{
			Vector2 curPos = Point.GetPosition();
			
			if (Input.GetKeyDown(KeyCode.H))
			{
				curPos.x -= 1.0f;
			}
			else if (Input.GetKeyDown(KeyCode.J))
			{
				curPos.y -= 1.0f;
			}
			else if (Input.GetKeyDown(KeyCode.K))
			{
				curPos.y += 1.0f;
			}
			else if (Input.GetKeyDown(KeyCode.L))
			{
				curPos.x += 1.0f;
			}
			
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(curPos);
			Point.SetMatrix(T);
		}


		void Code4()
		{
			Vector2 curPos = Point.GetPosition();
			
			if (Input.GetKey(KeyCode.H))
			{
				curPos.x -= 0.05f;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				curPos.x += 0.05f;
			}
			
			if (Input.GetKey(KeyCode.J))
			{
				curPos.y -= 0.05f;
			}
			else if (Input.GetKey(KeyCode.K))
			{
				curPos.y += 0.05f;
			}
			
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(curPos);
			Point.SetMatrix(T);
		}


		void Code5()
		{
			if (Input.GetKey(KeyCode.H))
			{
				i_forwardDegree += 1;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				i_forwardDegree -= 1;
			}
			
			THMatrix3x3 R = TH2DMath.GetRotation3x3(i_forwardDegree);
			Vector2 forwardDir = R * new Vector3(0, 1, 1);
			
			Point.SetMatrix(THMatrix3x3.identity);
		}


		void Code6()
		{
			Vector2 curPos = Point.GetPosition();
			
			if (Input.GetKey(KeyCode.H))
			{
				i_forwardDegree += 2;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				i_forwardDegree -= 2;
			}
			
			THMatrix3x3 R = TH2DMath.GetRotation3x3(i_forwardDegree);
			Vector2 forwardDir = R * new Vector3(0, 1, 1);
			
			if (Input.GetKeyDown(KeyCode.S))
			{
				float d = 0.5f;
				curPos += d * forwardDir;
			}
			
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(curPos);
			Point.SetMatrix(T);
		}


		void Code7()
		{
			Vector2 curPos = Point.GetPosition();
			
			if (Input.GetKey(KeyCode.H))
			{
				i_forwardDegree += 2;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				i_forwardDegree -= 2;
			}
			
			THMatrix3x3 R = TH2DMath.GetRotation3x3(i_forwardDegree);
			Vector2 forwardDir = R * new Vector3(0, 1, 1);
			
			float d = 0.03f;
			Vector2 newPos = (Input.GetKey(KeyCode.S)) ? curPos + d * forwardDir : curPos;
			
			THMatrix3x3 T = TH2DMath.GetTranslation3x3(newPos);
			Point.SetMatrix(T);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

				case 4 :	Code4();  break;

				case 5 :	Code5();  break;

				case 6 :	Code6();  break;

				case 7 :	Code7();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
			if (MatchCase(5, 6, 7))
			{
				THMatrix3x3 R = TH2DMath.GetRotation3x3(i_forwardDegree);
				THMatrix3x3 T = TH2DMath.GetTranslation3x3(Point.GetPosition());
				DirBar.SetMatrix(T * R);
			}
		}


		static Sec208 pr_instance = new Sec208(7);

		public static Sec208 PRGSI()
		{
			return pr_instance;
		}


		private Sec208(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Point = CreateObject_Obj2D("LPointB");
				DirBar = CreateObject_Obj2D("DirBar");

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);
			

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			i_forwardDegree = 0;
			
			if (MatchCase(1, 2))
			{
			}
			else if (MatchCase(3, 4))
			{
				BSAuxFuncs.SetVisible(1, Point.gameObject);
				Point.SetMatrix(THMatrix3x3.identity);
			}
			else if (MatchCase(5, 6, 7))
			{
				BSAuxFuncs.SetVisible(1, Point.gameObject);
				BSAuxFuncs.SetVisible(1, DirBar.gameObject);
				Point.SetMatrix(THMatrix3x3.identity);
				DirBar.SetMatrix(THMatrix3x3.identity);
			}
		}

	}

}
