//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec219
{
	public class Sec219 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Green;
		THObject2D Blue;
		
		THObject2D RectB;
		THObject2D RectG;
		THObject2D DiskB;
		THObject2D DiskG;


		// Instance Variables
		Vector2[] i_initMinMaxGreen;
		Vector2[] i_initMinMaxBlue;
		
		int i_reboundCount;
		Vector2 i_reboundDir;
		
		float i_radBlue;
		float i_radGreen;
		
		int pr_degGreen;
		Vector2 pr_prePos;
		bool pr_isHitColor;




		void Code1()
		{
			if (!i_INITIALIZED)
			{
				i_radBlue = 1.0f;
				i_radGreen = 1.0f;
				i_MOVE = true;
				
				i_INITIALIZED = true;
			}
			
			
			if (Input.GetKeyDown(KeyCode.S))  // Greenの運動の停止/再開
			{
				i_MOVE = !i_MOVE;
			}
			
			if (i_MOVE)
			{
				GreenMotion(1);  // Greenを適当に運動させる
			}
			
			Vector2 posB = Blue.GetPosition();
			
			float speed = 0.10f;
			if (Input.GetKey(KeyCode.H))
			{
				posB.x -= speed;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				posB.x += speed;
			}
			
			if (Input.GetKey(KeyCode.J))
			{
				posB.y -= speed;
			}
			else if (Input.GetKey(KeyCode.K))
			{
				posB.y += speed;
			}
			
			Blue.SetPosition(posB);
			
			Vector2 posG = Green.GetPosition();
			bool bColl = CollisionTest_Disk_Disk(posB, i_radBlue, posG, i_radGreen);
			Hit(bColl);
		}


		void Code2()
		{
			if (!i_INITIALIZED)
			{
				i_initMinMaxGreen = new Vector2[] { new Vector2(-3, -1), new Vector2(3, 1) };
				i_initMinMaxBlue = new Vector2[] { new Vector2(-3, -1), new Vector2(3, 1) };
				i_MOVE = true;
				
				i_INITIALIZED = true;
			}
			
			
			if (Input.GetKeyDown(KeyCode.S))  // Greenの運動の停止/再開
			{
				i_MOVE = !i_MOVE;
			}
			
			if (i_MOVE)
			{
				GreenMotion(1);  // Greenを適当に運動させる
			}
			
			Vector2 posB = Blue.GetPosition();
			
			float speed = 0.1f;
			if (Input.GetKey(KeyCode.H))
			{
				posB.x -= speed;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				posB.x += speed;
			}
			
			if (Input.GetKey(KeyCode.J))
			{
				posB.y -= speed;
			}
			else if (Input.GetKey(KeyCode.K))
			{
				posB.y += speed;
			}
			
			Blue.SetPosition(posB);
			
			Vector2 posG = Green.GetPosition();
			Vector2 minG = posG + i_initMinMaxGreen[0];
			Vector2 maxG = posG + i_initMinMaxGreen[1];
			Vector2 minB = posB + i_initMinMaxBlue[0];
			Vector2 maxB = posB + i_initMinMaxBlue[1];
			
			bool bColl = CollisionTest_AABB_AABB(minG, maxG, minB, maxB);
			Hit(bColl);
		}


		void Code3()
		{
			if (!i_INITIALIZED)
			{
				i_initMinMaxGreen = new Vector2[] { new Vector2(-3, -1), new Vector2(3, 1) };
				i_initMinMaxBlue = new Vector2[] { new Vector2(-3, -1), new Vector2(3, 1) };
				
				i_reboundCount = 0;
				i_MOVE = true;
				
				i_INITIALIZED = true;
			}
			
			
			if (i_reboundCount > 0)
			{
				i_reboundCount--;
				
				float aa = 0.4f;
				var npG = Green.GetPosition() - aa * i_reboundDir;
				var npB = Blue.GetPosition() + aa * i_reboundDir;
				Green.SetPosition(npG);
				Blue.SetPosition(npB);
				
				i_reboundDir = Vector2.zero;
				return;
			}
			
			if (Input.GetKeyDown(KeyCode.S))  // Greenの運動の停止/再開
			{
				i_MOVE = !i_MOVE;
			}
			
			if (i_MOVE)
			{
				GreenMotion(1);  // Greenを適当に運動させる
			}
			
			Vector2 posB = Blue.GetPosition();
			
			float speed = 0.15f;
			if (Input.GetKey(KeyCode.H))
			{
				posB.x -= speed;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				posB.x += speed;
			}
			
			if (Input.GetKey(KeyCode.J))
			{
				posB.y -= speed;
			}
			else if (Input.GetKey(KeyCode.K))
			{
				posB.y += speed;
			}
			
			Blue.SetPosition(posB);
			
			Vector2 posG = Green.GetPosition();
			Vector2 minG = posG + i_initMinMaxGreen[0];
			Vector2 maxG = posG + i_initMinMaxGreen[1];
			Vector2 minB = posB + i_initMinMaxBlue[0];
			Vector2 maxB = posB + i_initMinMaxBlue[1];
			
			bool bColl = CollisionTest_AABB_AABB(minG, maxG, minB, maxB);
			if (bColl)
			{
				i_reboundCount = 2;
			}
			else
			{
				if (maxB.x < minG.x)
				{
					i_reboundDir = -Vector2.right;
				}
				else if (maxG.x < minB.x)
				{
					i_reboundDir = Vector2.right;
				}
				else if (maxB.y < minG.y)
				{
					i_reboundDir = -Vector2.up;
				}
				else if (maxG.y < minB.y)
				{
					i_reboundDir = Vector2.up;
				}
			}
		}




		bool CollisionTest_Disk_Disk(Vector2 C1, float r1, Vector2 C2, float r2)
		{
			float l = (C1 - C2).magnitude;
			
			if (r1 + r2 >= l)
			{
				return true;
			}
			
			return false;
		}
		
		
		bool CollisionTest_AABB_AABB(Vector2 minA, Vector2 maxA, Vector2 minB, Vector2 maxB)
		{
			if (minA.x < maxB.x && minA.y < maxB.y &&
			minB.x < maxA.x && minB.y < maxA.y)
			{
				return true;
			}
			
			return false;
		}
		
		
		void GreenMotion(int id)
		{
			if (MatchCase(1, 2))
			{
				if (pr_degGreen == 0)
				{
					if (id == 0)
					{
						Blue.SetPosition(0, 0);
					}
					else
					{
						Blue.SetPosition(0, 8);
					}
				}
				
				if (id == 0)
				{
					pr_degGreen++;
					float x = 6.0f * Mathf.Sin(pr_degGreen * Mathf.Deg2Rad);
					Green.SetPosition(x, 5);
				}
				else if (id == 1)
				{
					pr_degGreen++;
					Vector2 pos = TH2DMath.GetRotation3x3(pr_degGreen) * new Vector3(5, 0, 1);
					Green.SetPosition(pos);
				}
			}
			else if (MatchCase(3))
			{
				if (pr_degGreen == 0)
				{
					if (id == 0)
					{
						pr_prePos = new Vector2(0, 3);
						Green.SetPosition(pr_prePos);
					}
					else
					{
						pr_prePos = new Vector2(0, 6);
						Green.SetPosition(pr_prePos);
					}
				}
				
				if (id == 0)
				{
					pr_degGreen++;
					var wp = Green.GetPosition();
					float x = 6.0f * Mathf.Sin(pr_degGreen * Mathf.Deg2Rad);      
					float dif = x - pr_prePos.x;
					wp.x += dif;
					Green.SetPosition(wp);
					pr_prePos = new Vector2(x, 0);  
				}
				else if (id == 1)
				{
					pr_degGreen++;
					var wp = Green.GetPosition();
					Vector2 pos = TH2DMath.GetRotation3x3(pr_degGreen) * new Vector2(0, 6);
					Vector2 dif = pos - pr_prePos;
					wp += dif;
					Green.SetPosition(wp);
					pr_prePos = pos;        
				}
			}
		}
		
		
		void Hit(bool coll)
		{
			if (coll)
			{
				if (!pr_isHitColor)
				{
					var mre = Green.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.8f, 0.2f, 0.1f, 1.0f));
					
					mre = Blue.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.7f, 0.1f, 0.1f, 0.6f));
				}
				
				pr_isHitColor = true;
			}
			else
			{
				if (pr_isHitColor)
				{
					var mre = Green.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.2703f, 0.7075f, 0.2703f, 1.0f));
					
					mre = Blue.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.2078f, 0.4705f, 0.6980f, 0.6f));
				}
				
				pr_isHitColor = false;
			}
		}


///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

				case 3 :	Code3();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
			if (MatchCase(1, 2, 3))
			{
				Vector3 pos = Blue.GetPosition();
				pos.z = -0.001f;
				Blue.transform.localPosition = pos;
			}
		}


		static Sec219 pr_instance = new Sec219(3);

		public static Sec219 PRGSI()
		{
			return pr_instance;
		}


		private Sec219(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				RectB = CreateObject_Obj2D("RectB");
				RectG = CreateObject_Obj2D("RectG");
				DiskB = CreateObject_Obj2D("UnitDiskB");
				DiskG = CreateObject_Obj2D("UnitDiskG");
				
				
				var trpMtrl = BSAuxFuncs.GetSemiTransparentMaterial(0.2078f, 0.4705f, 0.6980f, 0.6f);
				var mre = RectB.gameObject.GetComponent<MeshRenderer>();
				mre.material = trpMtrl;
				
				mre = DiskB.gameObject.GetComponent<MeshRenderer>();
				mre.material = trpMtrl;

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, DiskB.gameObject);
				BSAuxFuncs.SetVisible(1, DiskG.gameObject);
				Blue = DiskB;
				Green = DiskG;
				
				Blue.SetMatrix(THMatrix3x3.identity);
				Green.SetMatrix(THMatrix3x3.identity);
				
				pr_degGreen = 0;
				Hit(false);
			}
			else if (MatchCase(2, 3))
			{
				BSAuxFuncs.SetVisible(1, RectB.gameObject);
				BSAuxFuncs.SetVisible(1, RectG.gameObject);
				Blue = RectB;
				Green = RectG;
				
				Blue.SetMatrix(THMatrix3x3.identity);
				Green.SetMatrix(THMatrix3x3.identity);
				
				pr_degGreen = 0;
				Hit(false);
			}
		}

	}

}
