//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec221
{
	public class Sec221 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		THObject2D Green;
		THObject2D Blue;


		// Instance Variables
		Vector2[] i_initVertsBlue;
		Vector2[] i_initVertsGreen;
		
		int i_degBlue;
		int i_degGreen;
		bool pr_isHitColor;




		void Code1()
		{
			if (!i_INITIALIZED)
			{
				i_initVertsGreen = new Vector2[]
				{
					new Vector2(3, 1), new Vector2(-3, 1),
					new Vector2(-3, -1), new Vector2(3, -1),
				};
				i_initVertsBlue = new Vector2[]
				{
					new Vector2(3, 1), new Vector2(-3, 1),
					new Vector2(-3, -1), new Vector2(3, -1),
				};
				i_degBlue = 0;
				i_degGreen = 0;
				
				i_INITIALIZED = true;
			}
			
			
			if (Input.GetKey(KeyCode.Q))
			{
				i_degGreen = (THUtil.IsShiftDown()) ? i_degGreen - 1 : i_degGreen + 1;
				THMatrix3x3 mtx = TH2DMath.GetTranslation3x3(0, 5) * TH2DMath.GetRotation3x3(i_degGreen);
				Green.SetMatrix(mtx);
			}
			
			
			Vector2 posB = Blue.GetPosition();
			
			float speed = 0.10f;
			if (Input.GetKey(KeyCode.H))
			{
				posB.x -= speed;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				posB.x += speed;
			}
			
			if (Input.GetKey(KeyCode.J))
			{
				posB.y -= speed;
			}
			else if (Input.GetKey(KeyCode.K))
			{
				posB.y += speed;
			}
			
			if (Input.GetKey(KeyCode.R))
			{
				i_degBlue = (THUtil.IsShiftDown()) ? i_degBlue - 1 : i_degBlue + 1;
			}
			
			THMatrix3x3 M = TH2DMath.GetTranslation3x3(posB) * TH2DMath.GetRotation3x3(i_degBlue);
			Blue.SetMatrix(M);
			
			
			Vector2[] vertsB = new Vector2[4];
			Vector2[] vertsG = new Vector2[4];
			THMatrix3x3 mtxB = Blue.GetMatrix();
			THMatrix3x3 mtxG = Green.GetMatrix();
			for (int i = 0; i < 4; i++)
			{
				vertsB[i] = mtxB * TH2DMath.ToVector3(i_initVertsBlue[i]);
				vertsG[i] = mtxG * TH2DMath.ToVector3(i_initVertsGreen[i]);
			}
			
			bool bColl = CollisionTest_OBB_OBB(vertsB, vertsG);
			Hit(bColl);
		}


		void Code2()
		{
			if (!i_INITIALIZED)
			{
				i_initVertsGreen = new Vector2[]
				{
					new Vector2(3, 1), new Vector2(-3, 1),
					new Vector2(-3, -1), new Vector2(3, -1),
				};
				i_initVertsBlue = new Vector2[]
				{
					new Vector2(3, 1), new Vector2(-3, 1),
					new Vector2(-3, -1), new Vector2(3, -1),
				};
				
				i_degBlue = 0;
				i_MOVE = true;
				
				i_INITIALIZED = true;
			}
			
			
			if (Input.GetKeyDown(KeyCode.S))
			{
				i_MOVE = !i_MOVE;
			}
			
			if (i_MOVE)
			{
				GreenMotion(0);
			}
			
			
			Vector2 posB = Blue.GetPosition();
			
			float speed = 0.10f;
			if (Input.GetKey(KeyCode.H))
			{
				posB.x -= speed;
			}
			else if (Input.GetKey(KeyCode.L))
			{
				posB.x += speed;
			}
			
			if (Input.GetKey(KeyCode.J))
			{
				posB.y -= speed;
			}
			else if (Input.GetKey(KeyCode.K))
			{
				posB.y += speed;
			}
			
			if (Input.GetKey(KeyCode.R))
			{
				i_degBlue = (THUtil.IsShiftDown()) ? i_degBlue - 1 : i_degBlue + 1;
			}
			
			THMatrix3x3 M = TH2DMath.GetTranslation3x3(posB) * TH2DMath.GetRotation3x3(i_degBlue);
			Blue.SetMatrix(M);
			
			
			Vector2[] vertsB = new Vector2[4];
			Vector2[] vertsG = new Vector2[4];
			THMatrix3x3 mtxB = Blue.GetMatrix();
			THMatrix3x3 mtxG = Green.GetMatrix();
			for (int i = 0; i < 4; i++)
			{
				vertsB[i] = mtxB * TH2DMath.ToVector3(i_initVertsBlue[i]);
				vertsG[i] = mtxG * TH2DMath.ToVector3(i_initVertsGreen[i]);
			}
			
			bool bColl = CollisionTest_OBB_OBB(vertsB, vertsG);
			Hit(bColl);
		}



		bool CollisionTest_OBB_OBB(Vector2[] vertsA, Vector2[] vertsB)
		{
			Vector2[] sideDirs =
			{
				vertsA[0] - vertsA[1], vertsA[1] - vertsA[2],
				vertsB[0] - vertsB[1], vertsB[1] - vertsB[2]
			};
			
			foreach (var u in sideDirs)
			{
				float minA = Vector2.Dot(vertsA[0], u);
				float maxA = minA;
				float minB = Vector2.Dot(vertsB[0], u);
				float maxB = minB;
				
				for (int i = 1; i < 4; i++)
				{
					float projA = Vector2.Dot(vertsA[i], u);
					if (projA < minA)		{ minA = projA; }
					else if (projA > maxA)	{ maxA = projA; }
					
					float projB = Vector2.Dot(vertsB[i], u);
					if (projB < minB)		{ minB = projB;	}
					else if (projB > maxB)	{ maxB = projB; }
				}
				
				if (maxB < minA || maxA < minB)
				{
					return false;
				}
			}
			
			return true;
		}
		
		
		void GreenMotion(int id)
		{
			if (i_degGreen == 0 && id == 1)
			{
				Blue.SetPosition(0, 8);
			}
			
			if (id == 0)
			{
				i_degGreen++;
				float x = 6.0f * Mathf.Sin(i_degGreen * Mathf.Deg2Rad);
				THMatrix3x3 M = TH2DMath.GetTranslation3x3(x, 5) * TH2DMath.GetRotation3x3(30);
				Green.SetMatrix(M);
			}
			else if (id == 1)
			{
				i_degGreen++;
				THMatrix3x3 M = TH2DMath.GetRotation3x3(i_degGreen) * TH2DMath.GetTranslation3x3(3, 0);
				Green.SetMatrix(M);
			}
		}
		
		
		void Hit(bool coll)
		{
			if (coll)
			{
				if (!pr_isHitColor)
				{
					var mre = Green.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.8f, 0.2f, 0.1f, 1.0f));
					
					mre = Blue.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.7f, 0.1f, 0.1f, 0.6f));
				}
				
				pr_isHitColor = true;
			}
			else
			{
				if (pr_isHitColor)
				{
					var mre = Green.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.2703f, 0.7075f, 0.2703f, 1.0f));
					
					mre = Blue.gameObject.GetComponent<MeshRenderer>();
					mre.material.SetColor("_Color", new Color(0.2078f, 0.4705f, 0.6980f, 0.6f));
				}
				
				pr_isHitColor = false;
			}
		}


///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
			if (MatchCase(1, 2))
			{
				Vector3 pos = Blue.GetPosition();
				pos.z = -0.001f;
				Blue.transform.localPosition = pos;
			}
		}


		static Sec221 pr_instance = new Sec221(2);

		public static Sec221 PRGSI()
		{
			return pr_instance;
		}


		private Sec221(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Blue = CreateObject_Obj2D("RectB");
				Green = CreateObject_Obj2D("RectG");
				
				var trpMtrl = BSAuxFuncs.GetSemiTransparentMaterial(0.2078f, 0.4705f, 0.6980f, 0.6f);
				var mre = Blue.gameObject.GetComponent<MeshRenderer>();
				mre.material = trpMtrl;

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(THMatrix3x3.identity);
			
			if (MatchCase(1, 2))
			{
				BSAuxFuncs.SetVisible(1, Blue.gameObject);
				BSAuxFuncs.SetVisible(1, Green.gameObject);
				
				Blue.SetMatrix(THMatrix3x3.identity);
				Green.SetMatrix(THMatrix3x3.identity);
				
				Green.SetPosition(0, 5);
				i_degGreen = 0;
				
				Hit(false);
			}
		}

	}

}
