//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec230
{
	public class Sec230 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		
		CustomJet Jet;
		CustomShell[] Shell;


		// Instance Variables
		
		
		
		public class CustomJet : THObject2D
		{
			public CustomJet(GameObject go) : base(go) { }

		}
		
		
		public class CustomShell : THObject2D
		{
			public CustomShell(GameObject go) : base(go) { }

		}



		void Code1()
		{
			if (!i_INITIALIZED)
			{
				
				i_INITIALIZED = true;
			}
			
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec230 pr_instance = new Sec230(1);

		public static Sec230 PRGSI()
		{
			return pr_instance;
		}


		private Sec230(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				Jet = (CustomJet)CreateObject_Others2D("Combat2");
				
				
				var src_Shell = (CustomShell)CreateObject_Others2D("DbShell");
				Shell = new CustomShell[60];
				for (int i = 0; i < Shell.Length; i++)
				{
					Shell[i] = (CustomShell)CreateObject_InsOthers2D(src_Shell.gameObject);
				}

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(12.6f, 400);
			
			SetCameraPosition_2D(0, 0);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetIdentity();
			
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, Jet.gameObject);
				Jet.SetIdentity();
				
				for (int i = 0; i < Shell.Length; i++)
				{
					BSAuxFuncs.SetVisible(1, Shell[i].gameObject);
					Shell[i].SetIdentity();

					Shell[i].SetPosition(-1000, 0);
				}
			}
		}

	}

}
