//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec231
{
	public class Sec231 : BSSuperExe
	{
		// Objects
		THObject2D CrdSys;
		THObject2D Red;
		THObject2D[] Green = new THObject2D[4];
		THObject2D[] Blue = new THObject2D[16];
		THObject2D Arrow;


		// Instance Variables
		float i_degree;
		
		readonly Vector2[] G =
		{
			new Vector2(0.0f, 3.3f), new Vector2(3.3f, 0.0f),
			new Vector2(0.0f, -3.3f), new Vector2(-3.3f, 0.0f),
		};
		
		readonly Vector2[] B =
		{
			new Vector2(0.0f, 1.15f), new Vector2(1.15f, 0.0f),
			new Vector2(0.0f, -1.15f), new Vector2(-1.15f, 0.0f),
		};




		void Code1()
		{
			if (!i_INITIALIZED)
			{

				i_INITIALIZED = true;
			}


			if (Input.GetKeyDown(KeyCode.S))
			{

			}

		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec231 pr_instance = new Sec231(1);

		public static Sec231 PRGSI()
		{
			return pr_instance;
		}


		private Sec231(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj2D("CoordinateSystem2D");
				var src_Red = CreateObject_Obj2D("WDR");
				var src_Green = CreateObject_Obj2D("WDG");
				var src_Blue = CreateObject_Obj2D("WDB");
				Arrow = CreateObject_Obj2D("ObjA");
				
				// Instantiate 
				Red = CreateObject_InsObj2D(src_Red.gameObject);
				
				for (int i = 0; i < 4; i++)
				{
					Green[i] = CreateObject_InsObj2D(src_Green.gameObject);
				}
				
				for (int i = 0; i < 16; i++)
				{
					Blue[i] = CreateObject_InsObj2D(src_Blue.gameObject);
				}

				pr_LOAD_OBJECTS = true;
			}

			SetOutputImageSize(10.2f, 400);
			
			SetCameraPosition_2D(0, 0);
			
			SetFPS(30);

			Preset();
		}


		protected override void Preset()
		{
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetIdentity();
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, Red.gameObject);
				Red.SetIdentity();
				BSAuxFuncs.SetVisible(1, Arrow.gameObject);
				Arrow.SetIdentity();
				
				for (int i = 0; i < 4; i++)
				{
					BSAuxFuncs.SetVisible(1, Green[i].gameObject);
					Green[i].SetIdentity();
				}
				
				for (int i = 0; i < 16; i++)
				{
					BSAuxFuncs.SetVisible(1, Blue[i].gameObject);
					Blue[i].SetIdentity();
				}
			}
		}

	}

}
