//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using OQJ_BSSuperMain;
using OQJ_Sec301;
using OQJ_Sec302;
using OQJ_Sec303;
using OQJ_Sec304;
using OQJ_Sec305;
using OQJ_Sec306;
using OQJ_Sec307;
using OQJ_Sec308;
using OQJ_Sec309;
using OQJ_Sec310;
using OQJ_Sec311;
using OQJ_Sec312;
using OQJ_Sec313;
using OQJ_Sec314;
using OQJ_Sec315;
using OQJ_Sec316;
using OQJ_Sec317;
using OQJ_Sec318;
using OQJ_Sec319;
using OQJ_Sec320;
using OQJ_Sec321;
using OQJ_Sec322;
using OQJ_Sec323;

using OQJ_RGAuxFuncs03;



namespace OQJ_Main03
{
	public class Main03 : BSSuperMain
	{
		public Main03()
		{
			BSSuperExe[] eos = {
				Sec301.PRGSI(), Sec302.PRGSI(), Sec303.PRGSI(), Sec304.PRGSI(), Sec305.PRGSI(),
				Sec306.PRGSI(), Sec307.PRGSI(), Sec308.PRGSI(), Sec309.PRGSI(), Sec310.PRGSI(),

				Sec311.PRGSI(), Sec312.PRGSI(), Sec313.PRGSI(), Sec314.PRGSI(), Sec315.PRGSI(),
				Sec316.PRGSI(), Sec317.PRGSI(), Sec318.PRGSI(), Sec319.PRGSI(), Sec320.PRGSI(),

				Sec321.PRGSI(), Sec322.PRGSI(), Sec323.PRGSI()
			};


			string[] repres =   
			{
				"Cylinder", "QSignboard1", "QSignboard2", "CubePart1", "CubePart2",
				"Trino", "Cube", "Sphere035", "CubePartA", "CubePartB",
				"FinBall", "RTSphere", "MiniPlane_mZ", "MiniPlane_zyx", "MiniPlane_zyz",
				"Stand", "GrReel", "Dice", "DPath", "BlueAxis", 
				"Octah", "Handle", "MiniBall",	"TriWheel_2", "GrTria",
				

				"C00", "C01", "C02", "C03", "C04", "C05", "C06", "C07", "C08", "C09",
				"C10", "C11", "C12", "C13", "C14", "C15", "C16", "C17", "C18", "C19",
				"C20", "C21", "C22", "C23", "C24", "C25",

				"PointB", "PointG", "RBSphere_1", "RBSphere_2",	"ShortPath_1",
				"ShortPath_2", "UnitRect", "MuCube", "CamAx"
			};


			BSData.CHAPTER_NR = 3;

			m_CoordinateSystemType = c_3D;
			m_ExeObjs = eos;
			m_RunObjRepres = repres;
		}


		protected override void InitAuxObjects()
		{
			BSAuxFuncs.CreateAuxCircle();

			BSAuxFuncs.CreateAuxSphereGrid();

			BSAuxFuncs.InitQuaterGrid(0.80f);	 

			RGAuxFuncs03.CreateArc90();

			RGAuxFuncs03.CreateRightZupCoordinateSystem();

			BSAuxFuncs.InitCoordinateSystem2D("TmpCS_2D");
		}


	} // Elsa



	public class ClReel : THObject3D
	{
		public float rotDeg;

		public float angVel;

		public int nextBaseline;

		public bool ROTATE;


		public ClReel(GameObject go, bool shadow = false) : base(go, shadow)
		{
		}
	}

}
	



