//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec301
{
	public class Sec301 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;




		void Code1()
		{
			Vector3 sta = Vector3.zero;          // 始点
			Vector3 end = new Vector3(4, 3, 2);  // 終点
			Vector3 v1 = end - sta;
			Debug.Log("v1" + v1 + "  mag : " + v1.magnitude);
			
			sta = new Vector3(2, 4, -2);
			end = new Vector3(5, 1, -6);
			Vector3 v2 = end - sta;
			Debug.Log("v2" + v2 + "  mag : " + v2.magnitude);
			
			sta = new Vector3(-3, 1, -2);
			end = new Vector3(3, 2, 0);
			Vector3 v3 = end - sta;
			Debug.Log("v3" + v3 + "  mag : " + v3.magnitude);
		}


		void Code2()
		{
			Vector3 v = new Vector3(-2, 5, 3);
			Vector3 w = new Vector3(4, 6, -5);
			Vector3 A = 8 * v + 3 * w;
			Debug.Log(A);
			
			v = new Vector3(2, -3, 11);
			w = new Vector3(8, -12, -6);
			A = 5 * v - 4 * w;
			Debug.Log(A);
			
			v = new Vector3(-4.52f, 0.63f, -8.11f);
			w = new Vector3(6.82f, 11.35f, -2.09f);
			A = 3.4f * v + 1.8f * w;
			Debug.Log("(" + A.x + ", " + A.y + ", " + A.z + ")");
			
			v = new Vector3(2.08f, -3.15f, -9.83f);
			w = new Vector3(2.89f, 2.46f, 4.18f);
			A = -8.1f * v - 5.4f * w;
			Debug.Log("(" + A.x + ", " + A.y + ", " + A.z + ")");
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec301 pr_instance = new Sec301(2);

		public static Sec301 PRGSI()
		{
			return pr_instance;
		}


		private Sec301(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1, 2))
			{
				CamPos = new Vector3(0.0f, 4.0f, -8.0f);
				TrgPos = Vector3.zero;
				uJ = Vector3.up;
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
