//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec304
{
	public class Sec304 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;




		void Code1()
		{
			Vector3 v1 = new Vector3(1.77f, 0.80f, -0.48f);
			Vector3 v2 = new Vector3(-2.06f, 5.45f, 1.45f);
			float dot = Vector3.Dot(v1.normalized, v2.normalized);
			Debug.Log(dot);
			
			v1 = new Vector3(3.17f, -1.29f, -2.07f);
			v2 = new Vector3(-3.97f, 1.61f, 2.59f);
			dot = Vector3.Dot(v1.normalized, v2.normalized);
			Debug.Log(dot);
		}


		void Code2()
		{
			Vector3 A = new Vector3(2.77f, 5.0f, 2.36f);
			Vector3 B = new Vector3(3.05f, 4.41f, 4.25f);
			Vector3 C = new Vector3(2.0f, 5.0f, 3.0f);
			Vector3 vB = B - A;
			Vector3 vC = C - A;
			float dot = Vector3.Dot(vB.normalized, vC.normalized);
			float radian = Mathf.Acos(dot);
			float deg = radian * Mathf.Rad2Deg;
			Debug.Log(deg);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec304 pr_instance = new Sec304(2);

		public static Sec304 PRGSI()
		{
			return pr_instance;
		}


		private Sec304(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1, 2))
			{
				CamPos = new Vector3(0.0f, 4.0f, -8.0f);
				TrgPos = Vector3.zero;
				uJ = Vector3.up;
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
