//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec307
{
	public class Sec307 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THObject3D Cylinder;




		void Code1()
		{
			Matrix4x4 I = Matrix4x4.identity;
			Matrix4x4 S = TH3DMath.GetScale4x4(2.0f);
			Matrix4x4 R = TH3DMath.GetRotation4x4(30.0f, Vector3.right);
			Matrix4x4 T = TH3DMath.GetTranslation4x4(0.0f, 0.0f, 4.0f);
			Matrix4x4 RS = R * S;
			Matrix4x4 TRS = T * R * S;
			
			Matrix4x4 M = T * R * S;
			Matrix4x4 M1 = T.inverse * M;
			Matrix4x4 M2 = R.inverse * M1;
			Matrix4x4 M3 = S.inverse * M2;
			
			Cylinder.SetMatrix(TRS);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec307 pr_instance = new Sec307(1);

		public static Sec307 PRGSI()
		{
			return pr_instance;
		}


		private Sec307(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Cylinder = CreateObject_Obj3D("Cylinder");

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, Cylinder.gameObject);
				Cylinder.SetMatrix(Matrix4x4.identity);
				
				CamPos = new Vector3(13.40505f, 12.3015f, -7.463205f);
				TrgPos = new Vector3(2.545195f, 5.639662f, -1.446417f);
				uJ = new Vector3(-0.4100531f, 0.881137f, 0.235487f);
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
