//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec312
{
	public class Sec312 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THObject3D Cube;


		// Instance Variables
		int i_shm = 0;




		void Code1()
		{
			Matrix4x4 S1 = TH3DMath.GetScale4x4(3.0f);
			//Matrix4x4 S2 = TH3DMath.GetScale4x4(1.0f, 4.0f, 1.0f);
			//Matrix4x4 S3 = TH3DMath.GetScale4x4(2.0f, 0.5f, 3.0f);
			Cube.SetMatrix(S1);
		}


		void Code2()
		{
			i_shm += 2;  
			float min = 1.0f;
			float max = 3.0f;
			float A = max - min;
			float scale = 0.5f * A * (-Mathf.Cos(i_shm * Mathf.Deg2Rad) + 1.0f) + min;
			Matrix4x4 S = TH3DMath.GetScale4x4(scale);
			Cube.SetMatrix(S);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec312 pr_instance = new Sec312(2);

		public static Sec312 PRGSI()
		{
			return pr_instance;
		}


		private Sec312(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Cube = CreateObject_Obj3D("Cube");

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			i_shm = 0;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1, 2))
			{
				BSAuxFuncs.SetVisible(1, Cube.gameObject);
				Cube.SetMatrix(Matrix4x4.identity);
				
				CamPos = new Vector3(10.9414f, 8.129365f, -15.16397f);
				TrgPos = new Vector3(2.656433f, 1.520376f, -3.676826f);
				uJ = new Vector3(-0.2503026f, 0.9061891f, 0.3408372f);
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
				
				if (MatchCase(1))
				{
					pr_LOOP_CODE = false;
				}
			}
		}

	}

}
