//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec319
{
	public class Sec319 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THObject3D Dice;
		THObject3D DPath;


		// Instance Variables
		int i_motionCounter;
		Matrix4x4 i_curRotation;
		int i_curSquare;
		List<Vector3[]> i_edgeList;
		
		readonly Vector3 A = new Vector3(4.5f, 0.5f, 2.5f);	
		
		readonly Vector3[] V =
		{
			new Vector3(4, 0, 3), new Vector3(5, 0, 3), new Vector3(6, 0, 3), new Vector3(4, 0, 4),  
			new Vector3(5, 0, 4), new Vector3(6, 0, 4), new Vector3(7, 0, 4), new Vector3(4, 0, 5),  
			new Vector3(5, 0, 5), new Vector3(6, 0, 5), new Vector3(7, 0, 5), new Vector3(8, 0, 5),  
			new Vector3(5, 0, 6), new Vector3(6, 0, 6), new Vector3(7, 0, 6)						
		};




		void Code1()
		{
			if (!i_INITIALIZED)
			{
				Dice.SetMatrix(TH3DMath.GetTranslation4x4(A));

				i_INITIALIZED = true;
			}


			if (Input.GetKeyDown(KeyCode.S))
			{
				i_MOVE = true;
			}

			if (!i_MOVE) { return; }


		}





///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec319 pr_instance = new Sec319(1);

		public static Sec319 PRGSI()
		{
			return pr_instance;
		}


		private Sec319(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Dice = CreateObject_Obj3D("Dice");
				DPath = CreateObject_Obj3D("DPath");

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, Dice.gameObject);
				BSAuxFuncs.SetVisible(1, DPath.gameObject);
				Dice.SetMatrix(Matrix4x4.identity);
				DPath.SetMatrix(Matrix4x4.identity);
				DPath.SetWorldPosition(4.0f, 0.02f, 2.0f);
				
				
				i_edgeList = new List<Vector3[]>()
				{
					new Vector3[]{ V[0],  V[1]},
					new Vector3[]{ V[3],  V[4]},
					new Vector3[]{ V[7],  V[8]},
					new Vector3[]{ V[12], V[8]},
					new Vector3[]{ V[13], V[9]},
					new Vector3[]{ V[14], V[10]},
					new Vector3[]{ V[11], V[10]},
					new Vector3[]{ V[6],  V[10]},
					new Vector3[]{ V[5],  V[9]},
					new Vector3[]{ V[5],  V[4]},
					new Vector3[]{ V[2],  V[1]}
				};
				
				CamPos = new Vector3(4.886537f, 5.291785f, -3.634611f);
				TrgPos = new Vector3(4.886537f, 0.8763647f, 1.994584f);
				uJ = new Vector3(0f, 0.7868286f, 0.6171716f);
				
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
			}
		}

	}

}
