//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec323
{
	public class Sec323 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		THObject3D Cube;
		
		GameObject DLight;



		// Instance Variables
		




		void Code1()
		{
			if (!i_INITIALIZED)
			{
				Cube.SetMatrix(TH3DMath.GetTranslation4x4(18.5f, 0.5f, 5.5f));

				i_INITIALIZED = true;
			}


			if ((Input.GetKeyDown(KeyCode.H) || Input.GetKeyDown(KeyCode.J) ||
				 Input.GetKeyDown(KeyCode.K) || Input.GetKeyDown(KeyCode.L)))
			{

			}

		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec323 pr_instance = new Sec323(1);

		public static Sec323 PRGSI()
		{
			return pr_instance;
		}


		private Sec323(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Cube = CreateObject_Obj3D("MuCube");
				
				// Directional Light
				DLight = BSAuxFuncs.GetDirectionalLight();

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos = new Vector3(0, 0, -10);
			Vector3 TrgPos = Vector3.zero;
			Vector3 uJ = Vector3.up;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, Cube.gameObject);
				Cube.SetMatrix(Matrix4x4.identity);
				
				CamPos = new Vector3(18.5f, 5.697898f, -3.401779f);
				TrgPos = new Vector3(18.5f, 2.820157f, 2.089988f);
				uJ = new Vector3(0f, 0.8857585f, 0.4641463f);
				
				if (DLight != null)
				{
					DLight.transform.localRotation = Quaternion.Euler(50, -30, 0);
				}
			}
			
			SetCameraPosition_3D(CamPos, TrgPos, uJ);
		}

	}

}
