//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using OQJ_BSSuperMain;
using OQJ_Sec401;
using OQJ_Sec402;
using OQJ_Sec403;
using OQJ_Sec404;
using OQJ_Sec405;
using OQJ_Sec406;
using OQJ_Sec407;
using OQJ_Sec408;
using OQJ_Sec409;
using OQJ_Sec410;
using OQJ_Sec411;
using OQJ_Sec412;
using OQJ_Sec413;
using OQJ_Sec414;
using OQJ_Sec415;
using OQJ_Sec416;
using OQJ_Sec417;
using OQJ_Sec418;
using OQJ_Sec419;
using OQJ_Sec420;
using OQJ_Sec421;
using OQJ_Sec422;
using OQJ_Sec423;
using OQJ_Sec424;

using OQJ_RGAuxFuncs04;


namespace OQJ_Main04
{
	public class Main04 : BSSuperMain
	{
		public Main04()
		{
			BSSuperExe[] eos =
			{
				Sec401.PRGSI(), Sec402.PRGSI(), Sec403.PRGSI(), Sec404.PRGSI(), Sec405.PRGSI(),
				Sec406.PRGSI(), Sec407.PRGSI(), Sec408.PRGSI(), Sec409.PRGSI(), Sec410.PRGSI(),

				Sec411.PRGSI(), Sec412.PRGSI(), Sec413.PRGSI(), Sec414.PRGSI(), Sec415.PRGSI(),
				Sec416.PRGSI(), Sec417.PRGSI(), Sec418.PRGSI(), Sec419.PRGSI(), Sec420.PRGSI(),

				Sec421.PRGSI(), Sec422.PRGSI(), Sec423.PRGSI(), Sec424.PRGSI()
			};



			string[] repres =
			{
				"Sphere_half", "PointB", "PlaneBody", "Propeller", "RTSphere",
				"RBird_body", "RBird_wingL", "RBird_wingR", "HeliBody", "MainRotor",
				"TailRotor", "WhBall", "Ring", "Grabber", "R2Sphere",
				"DBrwnArm", "GapDisk", "Tent_R", "Tent_G", "Tent_B",
				"MBlPole", "MBlArm", "SkyBox", "BrProp", "YLine",
				"PrismBottom", "PrismTop", "CubeBottom", "CylinderBottom", "CylinderTop",
				"PrismSide", "CubeSide", "CylinderSide", "Plinth", "Platter",
				"Record", "Tonearm", "Adjuster", "Stand", "Support",
				"Wheel", "BoundingRect", "Cabin", "Runway2", "UpperLeg", 
				"LowerLeg", "DoorA", "DoorB", "Airplane", "UnitRect", 
				"TankBody", "Turret_2", "Barrel", "TrackBit", "TrackWheel",

				"PrsGreen", "BlBase", "BlBeam", "UnitCube01", "BallB",
				"BallR", "MlCannon", "Battery", "MlShell_A", "MlShell_B",
				"FNavy", "FShell", "TShell", "CheckSphere", "RTJ",
				"MiniWheel", "MiniShell", "BoxMG", "XZCylinder01", "CStar",
				"CTorus", "CCrystal", "FloorCh", "NrSt_1", "NrSt_2",
				"NrSt_3", "NrSt_4", "NrSt_5", "LCM_0", "LCM_1",
				"LCM_2", "LCM_3", "LCM_4", "MiniCannon", "ZTank",
				"DBlCube", "Chaser", "Square01", "CCoin","DBlDisk", 
				"SnPart"
			};


			BSData.CHAPTER_NR = 4;


			m_CoordinateSystemType = c_3D;
			m_ExeObjs = eos;
			m_RunObjRepres = repres;
		}



		protected override void InitAuxObjects()
		{
			BSAuxFuncs.CreateAuxLine(new Color(0.5f, 0.0f, 0.5f));

			BSAuxFuncs.CreateAuxLine(new Color(0.55f, 0.06f, 0.51f), "AuxTrj");

			BSAuxFuncs.CreateAuxLine(new Color(0.8f, 0.8f, 0.0f), "AuxRay");

			BSAuxFuncs.CreateAuxCircle();

			BSAuxFuncs.CreateAuxSphereGrid();

			BSAuxFuncs.InitCoordinateSystem2D("TmpCS_2D");

			RGAuxFuncs04.CreateLargeCoordinateSystem();

		} // InitAuxObjects()

	}

} // Elsa

