//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec417
{
	public class Sec417 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THObject3D Support;
		THObject3D Wheel;
		THObject3D[] Cabin;
		THObject3D BoundingRect;


		// Instance Variables
		float i_degWheel;
		
		readonly Vector3 c_attachPos_Wheel = new Vector3(0.0f, 8.0f, 0.0f);
		
		readonly Vector3 c_CabinPos0 = new Vector3(5.384474f, 0.0f, 0.0f);
		readonly Vector3[] c_initCabinPositions = new Vector3[12];




		void Code1()
		{

		}



		void Code2()
		{

		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec417 pr_instance = new Sec417(2);

		public static Sec417 PRGSI()
		{
			return pr_instance;
		}


		private Sec417(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Support = CreateObject_Obj3D("Support", true);
				Wheel = CreateObject_Obj3D("Wheel", true);
				BoundingRect = CreateObject_Obj3D("BoundingRect");
				
				var src_Cabin = CreateObject_Obj3D("Cabin", true);
				Cabin = new THObject3D[12];
				for (int i = 0; i < Cabin.Length; i++)
				{
					Cabin[i] = CreateObject_InsObj3D(src_Cabin.gameObject, true);
				}
				
				
				c_initCabinPositions[0] = c_CabinPos0;
				for (int i = 1; i < Cabin.Length; i++)
				{
					Matrix4x4 R = TH3DMath.GetRotation4x4(i * 30, Vector3.forward);
					c_initCabinPositions[i] = R * TH3DMath.ToVector4(c_CabinPos0);
				}

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			
			i_degWheel = 0.0f;
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, Support.gameObject);
				BSAuxFuncs.SetVisible(1, Wheel.gameObject);
				BSAuxFuncs.SetVisible(1, BoundingRect.gameObject);
				Support.SetIdentity();
				Wheel.SetIdentity();
				BoundingRect.SetIdentity();
				
				for (int i = 0; i < Cabin.Length; i++)
				{
					BSAuxFuncs.SetVisible(1, Cabin[i].gameObject);
					Cabin[i].SetIdentity();
				}
				
				BoundingRect.SetLocalPosition(12.0f, 0.02f, 8.0f);
				
				CamPos = new Vector3(20.898129f, 11.19757f, -2.38777f);
				TrgPos = new Vector3(14.308056f, 7.042433f, 7.6953616f);
				uJ = new Vector3(-0.1765675f, 0.9453357f, 0.2741611f);
				
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
			}
			else if (MatchCase(2))
			{
				BSAuxFuncs.SetVisible(1, Support.gameObject);
				BSAuxFuncs.SetVisible(1, Wheel.gameObject);
				BSAuxFuncs.SetVisible(1, BoundingRect.gameObject);
				Support.SetIdentity();
				Wheel.SetIdentity();
				BoundingRect.SetIdentity();
				
				for (int i = 0; i < Cabin.Length; i++)
				{
					BSAuxFuncs.SetVisible(1, Cabin[i].gameObject);
					Cabin[i].SetIdentity();
				}
				
				BoundingRect.transform.localPosition = new Vector3(12.0f, 0.02f, 8.0f);
				BoundingRect.transform.localRotation = Quaternion.AngleAxis(30.0f, Vector3.up);
				
				CamPos = new Vector3(13.95892f, 11.45713f, -6.239676f);
				TrgPos = new Vector3(13.79168f, 8.621506f, 1.963906f);
				uJ = new Vector3(0.01137143f, 0.9449984f, 0.3268772f);
				
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
			}
		}

	}

}
