//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec421
{
	public class Sec421 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THObject3D Sphere;
		THObject3D Triangle;
		THObject3D Wheel;
		
		GameObject MainCamera;
		GameObject DLight;
		GameObject SubLight;


		// Instance Variables
		
		readonly float c_radSphere = 8.0f;
		
		readonly float c_radWheel = 0.6f;
		
		



		void Code1()
		{
			if (!i_INITIALIZED)
			{
				i_frameCount = 0;
				i_MOVE = false;

				i_INITIALIZED = true;
			}


			if (Input.GetKeyDown(KeyCode.S))
			{
				i_MOVE = !i_MOVE;
			}


			if (i_MOVE)
			{
				i_frameCount++;

				if (i_frameCount <= 600)
				{
				}
				else if (i_frameCount <= 900)
				{
				}
				else if (i_frameCount <= 1500)
				{
				}
			}

		}



		void Code2()
		{
			if (!i_INITIALIZED)
			{
				i_frameCount = 0;
				i_MOVE = false;

				i_INITIALIZED = true;
			}


			if (Input.GetKeyDown(KeyCode.S))
			{
				i_MOVE = !i_MOVE;
			}


			if (i_MOVE)
			{
				i_frameCount++;

				if (i_frameCount <= 600)
				{
				}
				else if (i_frameCount <= 900)
				{
				}
				else if (i_frameCount <= 1500)
				{
				}
			}

		}





///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		// PR Variables

		float pr_revSph;
		float pr_rotSph;
		
		Vector3 pr_localPosition;
		Matrix4x4 pr_localRotation;
		
		Matrix4x4 pr_rotPerFrame_N2S;   
		Matrix4x4 pr_rotPerFrame_CD;    
		Matrix4x4 pr_rotPerFrame_S2N;   
		
		int pr_VIEW_TYPE;



		void SphereMotion()
		{
			pr_revSph -= 0.2f;
			pr_rotSph -= 0.3f;
			
			Vector3 np = TH3DMath.GetEulerRotation4x4(-25, 10, 20) *
			TH3DMath.GetRotation4x4(pr_revSph, Vector3.up) * new Vector3(20, 0, 0);
			np += new Vector3(28, 22, 8);
			Matrix4x4 traSph = TH3DMath.GetTranslation4x4(np);
			
			Matrix4x4 rotSph = TH3DMath.GetRotation4x4(30, Vector3.forward) *
			TH3DMath.GetRotation4x4(pr_rotSph, Vector3.up);
			Matrix4x4 localSphere = traSph * rotSph;
			
			Sphere.SetMatrix(localSphere);
		}
		
		
		
		Matrix4x4 GetSphereMatrix()
		{
			return Sphere.GetMatrix();
		}
		



		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
			SphereMotion();
		}


		void PostProcess()
		{
			if (Input.GetKeyDown(KeyCode.V))
			{
				pr_VIEW_TYPE = (pr_VIEW_TYPE + 1) % 3;
				
				if (pr_VIEW_TYPE == 1)
				{
					MainCamera.transform.position = new Vector3(4.603865f, 12.21542f, -52.13063f);
					MainCamera.transform.rotation = Quaternion.Euler(353.8746f, 27.5657f, 1.4971f);
				}
				else if (pr_VIEW_TYPE == 2)
				{
					MainCamera.transform.position = new Vector3(79.60812f, 55.97025f, 26.44154f);
					MainCamera.transform.rotation = Quaternion.Euler(42.6349f, 250.0652f, 357.9171f);
				}
			}
			
			
			if (i_MOVE)
			{
				if (i_frameCount <= 600)
				{
					pr_localPosition = pr_rotPerFrame_N2S * pr_localPosition;
					pr_localRotation = pr_rotPerFrame_N2S * pr_localRotation;
				}
				else if (i_frameCount <= 900)
				{
					pr_localPosition = pr_rotPerFrame_CD * pr_localPosition;
					pr_localRotation = pr_rotPerFrame_CD * pr_localRotation;
				}
				else if (i_frameCount <= 1500)
				{
					pr_localPosition = pr_rotPerFrame_S2N * pr_localPosition;
					pr_localRotation = pr_rotPerFrame_S2N * pr_localRotation;
				}
			}
			
			
			if (pr_VIEW_TYPE == 0)
			{
				Matrix4x4 localSphere = GetSphereMatrix();
				
				Matrix4x4 CamMtx = localSphere * TH3DMath.GetTranslation4x4(pr_localPosition) * pr_localRotation;
				MainCamera.transform.position = CamMtx.GetColumn(3);
				MainCamera.transform.rotation = TH3DMath.GetRotationPart(CamMtx);
			}
			
			
			BSData.CameraController3D.UpdateCameraData();
		}


		static Sec421 pr_instance = new Sec421(2);

		public static Sec421 PRGSI()
		{
			return pr_instance;
		}


		private Sec421(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Sphere = CreateObject_Obj3D("CheckSphere", true);
				Triangle = CreateObject_Obj3D("RTJ", true);
				Wheel = CreateObject_Obj3D("MiniWheel", true);
				
				BSAuxFuncs.SetStandardMaterial(Triangle, 0.9056f, 0.4035f, 0.3631f, 0.0f);
				
				
				MainCamera = BSAuxFuncs.GetMainCamera();
				
				
				DLight = BSAuxFuncs.GetDirectionalLight();
				DLight.GetComponent<Light>().intensity = 0.75f;
				
				
				SubLight = new GameObject("Sub Light");
				Light LC = SubLight.AddComponent<Light>();
				LC.color = new Color(0.9301f, 0.8955f, 0.889f);
				LC.type = LightType.Directional;
				LC.intensity = 0.3f;
				LC.shadows = LightShadows.Soft;
				SubLight.transform.rotation = Quaternion.Euler(-50, 120, 0);
				
				QualitySettings.shadowCascades = 4;

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos = new Vector3(0, 0, -10);
			Vector3 TrgPos = Vector3.zero;
			Vector3 uJ = Vector3.up;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetIdentity();
			
			if (MatchCase(1, 2))
			{
				CrdSys.SetLocalScale(2.0f);
				
				BSAuxFuncs.SetVisible(1, Sphere.gameObject);
				Sphere.SetIdentity();
				
				if (MatchCase(1))
				{
					BSAuxFuncs.SetVisible(1, Triangle.gameObject);
					Triangle.SetIdentity();
				}
				else
				{
					BSAuxFuncs.SetVisible(1, Wheel.gameObject);
					Wheel.SetIdentity();
				}
				
				pr_localPosition = new Vector3(-3.2f, c_radSphere + 3.2f, 2.4f);
				pr_localRotation = TH3DMath.GetEulerRotation4x4(33, 145, 0);
				
				float adg = 0.3f;
				pr_rotPerFrame_N2S = TH3DMath.GetRotation4x4(-adg, Vector3.right);
				pr_rotPerFrame_CD = TH3DMath.GetRotation4x4(-adg, Vector3.up);
				pr_rotPerFrame_S2N = TH3DMath.GetRotation4x4(-adg, Vector3.forward);
				
				pr_VIEW_TYPE = 0;
				
				if (DLight != null)
				{
					DLight.transform.localRotation = Quaternion.Euler(30, 30, 0);
				}
			}
			
			SetCameraPosition_3D(CamPos, TrgPos, uJ);
		}

	}

}
