//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using OQJ_BSSuperMain;
using OQJ_Sec501;
using OQJ_Sec502;
using OQJ_Sec503;
using OQJ_Sec504;
using OQJ_Sec505;
using OQJ_Sec506;
using OQJ_Sec507;
using OQJ_Sec508;
using OQJ_Sec509;


namespace OQJ_Main05
{
	public class Main05 : BSSuperMain
	{
		public Main05()
		{
			BSSuperExe[] eos = {
				Sec501.PRGSI(), Sec502.PRGSI(), Sec503.PRGSI(), Sec504.PRGSI(), Sec505.PRGSI(),
				Sec506.PRGSI(), Sec507.PRGSI(), Sec508.PRGSI(), Sec509.PRGSI()
			};


			string[] repres =
			{
				"Stick1", "Stick2", "Stick3", "RGBCube", "WhBall",
				"Ring", "Grabber", "Sphere_half", "PointB", "PlaneBody",
				"Propeller", "GapDisk", "DBrwnArm", "R2Sphere", "MBlPole", 
				"MBlArm", "SkyBox", "BrProp", "YLine", "Dice",
				"DPath", "CubeBottom", "CubeSide", "CubeSide2", "RotStand",
				"SlidePipe", "Fan", "Guard", "BaseStand", "BoundingSquare",
				"FNavy", "FShell"
			};


			BSData.CHAPTER_NR = 5;

			m_CoordinateSystemType = c_3D;
			m_ExeObjs = eos;
			m_RunObjRepres = repres;
		}


		protected override void InitAuxObjects()
		{
			BSAuxFuncs.CreateAuxLine(new Color(0.5f, 0.0f, 0.5f));

			BSAuxFuncs.CreateAuxCircle();
		}

	}

} // Elsa

