//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;


namespace OQJ_Recursive
{
	public class Recursive
	{
		private int m_ID;

		private bool m_UPDATE_LOCAL = false;
		private bool m_UPDATE_WORLD = false;

		private Recursive m_parent = null;
		private List<Recursive> m_children = new List<Recursive>();

		public Recursive(int id)
		{
			m_ID = id;
		}

		public void SetParent(Recursive p)
		{
			m_parent = p;
			m_parent.m_children.Add(this);
		}

		public void SomeChange()
		{
			m_UPDATE_LOCAL = true;
			NotifyChain();
		}

		private void NotifyChain()
		{
			m_UPDATE_WORLD = true;

			foreach (var child in m_children)
			{
				child.NotifyChain();
			}
		}

		public void UpdateChain()
		{
			UpdateMessage();

			foreach (var child in m_children)
			{
				child.UpdateChain();
			}
		}

		private void UpdateMessage()
		{
			if (m_UPDATE_WORLD)
			{
				if (m_UPDATE_LOCAL)
				{
					Debug.Log("*Update Local : Obj" + m_ID + "*");
					m_UPDATE_LOCAL = false;
				}

				Debug.Log("=Update World : Obj" + m_ID + "=");
				m_UPDATE_WORLD = false;
			}
		}
	}
} // Elsa


