//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;




namespace OQJ_Sec502
{
	public class Sec502 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THObject3D Cube;
		
		GameObject DLight;




		void Code1()
		{
			Cube.transform.localScale = new Vector3(2, 2, 2);
			Cube.transform.localRotation = Quaternion.AngleAxis(-90, Vector3.up);
			Cube.transform.localPosition = new Vector3(6, 0, 0);
		}


		void Code2()
		{
			Cube.transform.localScale = new Vector3(1f, 1.5f, 1f);
			Cube.transform.localRotation = Quaternion.AngleAxis(180, Vector3.forward);
			Cube.transform.localPosition = new Vector3(5f, 1.5f, 10f);
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec502 pr_instance = new Sec502(2);

		public static Sec502 PRGSI()
		{
			return pr_instance;
		}


		private Sec502(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");
				Cube = CreateObject_Obj3D("RGBCube");
				
				
				DLight = BSAuxFuncs.GetDirectionalLight();
				if (DLight != null)
				{
					DLight.transform.localRotation = Quaternion.Euler(50, 210, 0);
				}

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1, 2))
			{
				BSAuxFuncs.SetVisible(1, Cube.gameObject);
				Cube.SetMatrix(Matrix4x4.identity);
				
				CamPos = new Vector3(14.17767f, 8.681284f, 15.95539f);
				TrgPos = new Vector3(6.856491f, 2.032327f, 5.470319f);
				uJ = new Vector3(-0.3164486f, 0.8853928f, -0.3404996f);
				
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
