//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using OQJ_Recursive;



namespace OQJ_Sec506
{
	public class Sec506 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;




		void Code1()
		{
			Recursive Obj1 = new Recursive(1);
			Recursive Obj2 = new Recursive(2);
			Recursive Obj3 = new Recursive(3);
			Recursive Obj4 = new Recursive(4);
			Recursive Obj5 = new Recursive(5);
			
			Obj2.SetParent(Obj1);
			Obj3.SetParent(Obj2);
			Obj4.SetParent(Obj3);
			Obj5.SetParent(Obj4);
			
			Obj4.SomeChange();
			
			Obj1.UpdateChain();
		}


		void Code2()
		{
			Recursive Obj1 = new Recursive(1);
			Recursive Obj2 = new Recursive(2);
			Recursive Obj3 = new Recursive(3);
			Recursive Obj4 = new Recursive(4);
			Recursive Obj5 = new Recursive(5);
			Recursive Obj6 = new Recursive(6);
			Recursive Obj7 = new Recursive(7);
			Recursive Obj8 = new Recursive(8);
			Recursive Obj9 = new Recursive(9);
			Recursive Obj10 = new Recursive(10);
			
			Obj2.SetParent(Obj1);
			Obj3.SetParent(Obj1);
			Obj4.SetParent(Obj1);
			
			Obj5.SetParent(Obj2);
			Obj6.SetParent(Obj3);
			Obj7.SetParent(Obj4);
			
			Obj8.SetParent(Obj5);
			Obj9.SetParent(Obj5);
			
			Obj10.SetParent(Obj6);
			
			Obj2.SomeChange();
			
			Obj1.UpdateChain();
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

				case 2 :	Code2();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec506 pr_instance = new Sec506(2);

		public static Sec506 PRGSI()
		{
			return pr_instance;
		}


		private Sec506(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Obj3D("CoordinateSystem3D");

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1, 2))
			{
				CamPos = new Vector3(0.0f, 4.0f, -8.0f);
				TrgPos = Vector3.zero;
				uJ = Vector3.up;
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
				
				pr_LOOP_CODE = false;
			}
		}

	}

}
