//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using OQJ_THBetaObject3D;



namespace OQJ_Sec509
{
	public class Sec509 : BSSuperExe
	{
		// Objects
		THObject3D CrdSys;
		
		THBetaObject3D BaseStand;	
		THBetaObject3D SlidePipe;	
		THBetaObject3D RotStand;
		THBetaObject3D Guard;
		THBetaObject3D Fan;
		THBetaObject3D BoundingSquare;
		
		GameObject DLight;


		// Instance Variables
		float i_heightSlidePipe = 0.0f;
		float i_degGuard;
		float i_degFan = 0.0f;
		float i_shmRotStand;	 
		
		bool i_HORIZONTAL_ROTATION = false;
		
		readonly Vector3 c_attachPos_Guard = new Vector3(0.0f, 2.1184f, 0.0f);	




		void Code1()
		{
			if (!i_INITIALIZED)
			{
				
				i_INITIALIZED = true;
			}
			
			
		}






///////////////////////////////////////////////////////////////////////////
//////////////////////////////// Backstage ////////////////////////////////


		public override void Update()
		{
			PreProcess();

			switch (THSettings.CODE_NR)
			{
				case 1 :	Code1();  break;

			}

			PostProcess();
		}


		void PreProcess()
		{
		}


		void PostProcess()
		{
		}


		static Sec509 pr_instance = new Sec509(1);

		public static Sec509 PRGSI()
		{
			return pr_instance;
		}


		private Sec509(int num_code) : base(num_code) { }


		public override void Initialize()
		{
			if(!pr_LOAD_OBJECTS)
			{
				CrdSys = CreateObject_Beta3D("CoordinateSystem3D");
				RotStand = CreateObject_Beta3D("RotStand");
				SlidePipe = CreateObject_Beta3D("SlidePipe");
				Fan = CreateObject_Beta3D("Fan");
				Guard = CreateObject_Beta3D("Guard");
				BaseStand = CreateObject_Beta3D("BaseStand");
				BoundingSquare = CreateObject_Beta3D("BoundingSquare");
				
				DLight = BSAuxFuncs.GetDirectionalLight();
				if (DLight != null)
				{
					DLight.transform.localRotation = Quaternion.Euler(30, -30, 0);
				}

				pr_LOAD_OBJECTS = true;
			}


			Preset();
		}


		protected override void Preset()
		{
			Vector3 CamPos;
			Vector3 TrgPos;
			Vector3 uJ;
			
			BSAuxFuncs.SetVisible(1, CrdSys.gameObject);
			CrdSys.SetMatrix(Matrix4x4.identity);
			
			if (MatchCase(1))
			{
				BSAuxFuncs.SetVisible(1, RotStand.gameObject);
				BSAuxFuncs.SetVisible(1, SlidePipe.gameObject);
				BSAuxFuncs.SetVisible(1, Fan.gameObject);
				BSAuxFuncs.SetVisible(1, Guard.gameObject);
				BSAuxFuncs.SetVisible(1, BaseStand.gameObject);
				BSAuxFuncs.SetVisible(1, BoundingSquare.gameObject);
				
				BoundingSquare.transform.localPosition = new Vector3(12.0f, 0.01f, -2.0f);
				
				SlidePipe.transform.SetParent(null);
				RotStand.transform.SetParent(null);
				Guard.transform.SetParent(null);
				Fan.transform.SetParent(null);
				
				SlidePipe.thTransform.Clear();
				RotStand.thTransform.Clear();
				Guard.thTransform.Clear();
				Fan.thTransform.Clear();
				BaseStand.thTransform.Clear();
				
				RotStand.SetIdentity();
				SlidePipe.SetIdentity();
				Fan.SetIdentity();
				Guard.SetIdentity();
				BaseStand.SetIdentity();
				
				CamPos = new Vector3(12.0f, 2.79307f, -5.903254f);		
				TrgPos = new Vector3(12.0f, 1.724999f, -2.0f);
				uJ = new Vector3(0f, 0.964541f, 0.2639331f);
				
				SetCameraPosition_3D(CamPos, TrgPos, uJ);
			}
		}

	}

}
