﻿//-------------------------------------------
// Copyright (c) 2020-2025, Redpoll's 60.
// https://www.eproph527tw.com/
//-------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using OQJ_BSSuperMain;


using OQJ_SecB01;




namespace OQJ_MainPB
{
	public class MainPB : BSSuperMain
	{
		public MainPB()
		{
			BSSuperExe[] eos =
			{
				SecB01.PRGSI()
			};


			string[] repres =
			{
				"SHR_B", "SHR_W",

			};


			BSData.CHAPTER_NR = 16;

			m_CoordinateSystemType = c_2D;
			m_ExeObjs = eos;
			m_RunObjRepres = repres;
		}



		protected override void InitAuxObjects()
		{

		}
	}


	public class ClEllipse : THObject2D
	{
		Vector2 m_position;
		public Vector2 position
		{
			set
			{
				m_position = value;
				SetPosition(m_position);
			}
			get
			{
				return m_position;
			}
		}


		float m_degree;
		public float degree
		{
			set
			{
				m_degree = value;
				float dians = Mathf.Deg2Rad * m_degree;
				float cosT = Mathf.Cos(dians);
				float sinT = Mathf.Sin(dians);
				m_localX = new Vector2(cosT, sinT);	
				m_localY = new Vector2(-sinT, cosT);

				SetRotation(m_degree);
			}
			get
			{
				return m_degree;
			}
		}

		Vector2 m_localX;
		public Vector2 localX {  get { return m_localX; }  }

		Vector2 m_localY;
		public Vector2 localY {  get { return m_localY; }  }

		float m_scaleX;
		public float scaleX
		{
			set
			{
				m_scaleX = value;
				SetScale(m_scaleX, m_scaleY);
			}
			get
			{
				return m_scaleX;
			}
		}

		float m_scaleY;
		public float scaleY
		{
			set
			{
				m_scaleY = value;
				SetScale(m_scaleX, m_scaleY);
			}
			get
			{
				return m_scaleY;
			}
		}


		public ClEllipse(GameObject go) : base(go)
		{
			m_position = Vector2.zero;
			m_degree = 0.0f;
			m_localX = Vector2.right;
			m_localY = Vector2.up;
			m_scaleX = 1.0f;
			m_scaleY = 1.0f;
		}
	}

}


